package com.sztzjy.money_management.mapper;

import com.sztzjy.money_management.entity.ObjectiveQuestion;
import com.sztzjy.money_management.entity.ObjectiveQuestionExample;
import com.sztzjy.money_management.entity.ObjectiveQuestionWithBLOBs;
import com.sztzjy.money_management.entity.dto.ObjectiveQuestionDto;
import com.sztzjy.money_management.entity.dto.TopicDto;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface ObjectiveQuestionMapper {
    long countByExample(ObjectiveQuestionExample example);

    int deleteByExample(ObjectiveQuestionExample example);

    int deleteByPrimaryKey(String objectiveId);

    int insert(ObjectiveQuestionWithBLOBs record);

    int insertSelective(ObjectiveQuestionWithBLOBs record);

    List<ObjectiveQuestionWithBLOBs> selectByExampleWithBLOBs(ObjectiveQuestionExample example);

    List<ObjectiveQuestion> selectByExample(ObjectiveQuestionExample example);

    ObjectiveQuestionWithBLOBs selectByPrimaryKey(String objectiveId);

    int updateByExampleSelective(@Param("record") ObjectiveQuestionWithBLOBs record, @Param("example") ObjectiveQuestionExample example);

    int updateByExampleWithBLOBs(@Param("record") ObjectiveQuestionWithBLOBs record, @Param("example") ObjectiveQuestionExample example);

    int updateByExample(@Param("record") ObjectiveQuestion record, @Param("example") ObjectiveQuestionExample example);

    int updateByPrimaryKeySelective(ObjectiveQuestionWithBLOBs record);

    int updateByPrimaryKeyWithBLOBs(ObjectiveQuestionWithBLOBs record);

    int updateByPrimaryKey(ObjectiveQuestion record);

    List<TopicDto> getObjectiveCountByChapterId(@Param("outLine") String outLine,
                                                @Param("chapterId") String chapterId);

    List<ObjectiveQuestionWithBLOBs> getObjectiveByType(@Param("type") Integer type,
                                                        @Param("outLine") String outLine,
                                                        @Param("subClass") String subClass,
                                                        @Param("content") String content,
                                                        @Param("schoolId") String schoolId);

    int batchDelete(@Param("list") List<String> objectiveQuestionId);

    int insertBatch(@Param("objectiveQuestionList") List<ObjectiveQuestionWithBLOBs> objectiveQuestionList);

    List<ObjectiveQuestionDto> getObjectiveCount10(@Param("chapterId") String chapterId);

    List<ObjectiveQuestionWithBLOBs> getObjectiveByRandom(@Param("type") int type,
                                                          @Param("count") int count,
                                                          @Param("outLine") String outLine,
                                                          @Param("subClass") String subclass,
                                                          @Param("schoolId") String schoolId);
}